# vim: set ft=spec: -*- rpm-spec -*-
# $Id: prc-tools,v 1.5 2005/05/18 10:17:02 raorn Exp $

Name: prc-tools
Version: 2.3
Release: alt1

Summary: GCC and related tools for Palm OS development
Group: Development/Other
License: GPL
Url: http://prc-tools.sourceforge.net/

# This is the canonical place to look for Palm OS-related header files and
# such on Unix-like file systems.
%define palmdev_prefix /opt/palmdev
# RPM macros
%define _update_palmdev_bin	%_bindir/palmdev-prep
%define update_palmdev		[ -x %_update_palmdev_bin ] && %_update_palmdev_bin -q ||:

%define _libexecdir /usr/libexec

%define m68k_target m68k-palmos
%define arm_target arm-palmos

# prc-tools is a virtual package
Requires: %name-common = %version-%release
Requires: %m68k_target-%name = %version-%release
Requires: %arm_target-%name = %version-%release

Source: http://download.sourceforge.net/prc-tools/%name-%version.tar.gz
Source1: ftp://ftp.gnu.org/pub/gnu/binutils/binutils-2.14.tar.bz2
Source2: ftp://gcc.gnu.org/pub/gcc/releases/gcc-2.95.3/gcc-2.95.3.tar.gz
Source3: ftp://gcc.gnu.org/pub/gcc/releases/gcc-3.3.1/gcc-core-3.3.1.tar.bz2
Source4: ftp://gcc.gnu.org/pub/gcc/releases/gcc-3.3.1/gcc-g++-3.3.1.tar.bz2
Source5: ftp://sources.redhat.com/pub/gdb/old-releases/gdb-5.3.tar.bz2

# Automatically added by buildreq on Mon May 16 2005
BuildRequires: flex gcc-c++ libstdc++-devel libreadline-devel libncurses-devel

%description
A complete compiler tool chain for building Palm OS applications in C or C++.
Includes (patched versions of) binutils 2.14, GCC 2.95.3 and GCC 3.3.1
along with various post-linker tools to produce Palm OS .prc files.

You will also need a Palm OS SDK and some way of creating user interface
resources, such as PilRC.

%package common
Summary: Common tools for Palm OS development
Group: Development/Other
Requires(post): %install_info
Requires(preun): %uninstall_info
PreReq: /etc/rpm/macros.d

%description common
Various post-linker tools to produce Palm OS .prc files.

You will also need m68k and/or arm targeted tools, Palm OS SDK and some
way of creating user interface resources, such as PilRC.

%package -n %m68k_target-%name
Summary: GCC and related tools for Motorola targeted Palm OS development
Group: Development/Other
PreReq: %name-common = %version-%release

%description -n %m68k_target-%name
A compiler tool chain for building Palm OS applications in C or C++.
Includes (patched versions of) binutils 2.14 and GCC 2.95.3, and requires
the various post-linker tools from a corresponding prc-tools-common package.

%package -n %arm_target-%name
Summary: GCC and related tools for ARM targeted Palm OS development
Group: Development/Other
PreReq: %name-common = %version-%release

%description -n %arm_target-%name
A compiler tool chain for building Palm OS armlets in C or C++.
Includes (patched versions of) binutils 2.14 and GCC 3.3.1, and requires
the various post-linker tools from a corresponding prc-tools-common package.

Note that this version of ARM prc-tools does not provide startup code or
other niceties:  by itself, it is only useful for building stand-alone
code resources such as armlets.

%package htmldocs
Summary: GCC, GDB, binutils, make, and prc-tools documentation as HTML
Group: Development/Other

%description htmldocs
GCC, GDB, binutils, make, and general prc-tools documentation in HTML
format.  The various native development packages and the main prc-tools
package, respectively, provide exactly this documentation in info format.
This optional package is for those who prefer HTML-formatted documentation.

By default, this package will be installed at %palmdev_prefix/doc, and
you should point your web browser at %palmdev_prefix/doc/index.html.
If you want to install it elsewhere, you can do so via the prefix and/or
relocation facilities of your RPM installation tool.

%prep
%setup -q -a1 -a2 -a3 -a4 -a5
%__cat *.palmos.diff | patch -p0

%__mv gcc-2.95.3 gcc295
# Rename each "package-x.y.z" directory to just "package"
for dir in *-*[0-9]; do
  %__mv $dir `echo $dir | sed 's/-[^-]*$//'`;
done

%build
%undefine __libtoolize
%define _configure_target --host=%_host_alias --build=%_host_alias
%remove_optflags -march=\[0-9a-z\]\* -mcpu=\[0-9a-z\]\*
%define __nprocs 1
%configure \
  --disable-nls \
  --with-system-zlib \
  --enable-targets=%m68k_target,%arm_target \
  --enable-languages="c,c++" \
  --with-palmdev-prefix=%palmdev_prefix \
  --disable-html-docs

%make_build

%install
%makeinstall

# post-install cleanup
%__rm -rf %buildroot%_man7dir
%__rm -rf %buildroot%_man1dir/[!bp]*
%__rm -rf %buildroot%_infodir/[!p]*
%__rm -rf %buildroot%_libdir/gcc-lib/*/*/install-tools
%__rm -rf %buildroot%_libdir/lib*.a
%__rm -rf %buildroot%_usr/*/bin/[cg]++
%__rm -rf %buildroot%_bindir/*-cpp
%__rm -rf %buildroot%_bindir/*-gcc-*
%__rm -rf %buildroot%_bindir/*-gcov
%__rm -rf %buildroot%_bindir/*-gccbug

%__mkdir_p %buildroot%palmdev_prefix

%__mkdir_p %buildroot%_sysconfdir/rpm/macros.d
%__cat <<EOF >%buildroot%_sysconfdir/rpm/macros.d/%name
%%_update_palmdev_bin	%%_bindir/palmdev-prep
%%update_palmdev	[ -x %%_update_palmdev_bin ] && %%_update_palmdev_bin -q ||:
%%clean_palmdev		[ "\$1" -eq 0 -a -x %%_update_palmdev_bin ] && %%_update_palmdev_bin -q ||:

%%palmdev_prefix /opt/palmdev
EOF

touch %buildroot%_datadir/%name/trapnumbers
touch %buildroot%_libdir/gcc-lib/%m68k_target/specs
touch %buildroot%_libdir/gcc-lib/%arm_target/specs

%post common
%update_palmdev
%install_info prc-tools.info

%preun common
[ "$1" = 0 -a -x %_update_palmdev_bin ] && %_update_palmdev_bin -q -r ||:
%uninstall_info prc-tools.info

%post -n %m68k_target-%name
%update_palmdev

%preun -n %m68k_target-%name
[ "$1" = 0 ] && %__rm -f %_libdir/gcc-lib/%m68k_target/specs ||:

%post -n %arm_target-%name
%update_palmdev

%preun -n %arm_target-%name
[ "$1" = 0 ] && %__rm -f %_libdir/gcc-lib/%arm_target/specs ||:

%files

%files common
%doc BUILDING.html COPYING README TODO prc-tools.spec
%_sysconfdir/rpm/macros.d/%name
%_bindir/*
%exclude %_bindir/%m68k_target-*
%exclude %_bindir/%arm_target-*
%_datadir/%name
%_infodir/prc-tools.info*
%_man1dir/build-prc.1*
%_man1dir/palmdev-prep.1*
%dir %palmdev_prefix
%exclude %_datadir/%name/trapnumbers
%ghost %config(noreplace,missingok) %verify(not size mtime md5) %_datadir/%name/trapnumbers

%files -n %m68k_target-%name
%_bindir/%m68k_target-*
%_usr/%m68k_target
%dir %_libdir/gcc-lib
%_libdir/gcc-lib/%m68k_target
%exclude %_libdir/gcc-lib/%m68k_target/specs
%ghost %config(noreplace,missingok) %verify(not size mtime md5) %_libdir/gcc-lib/%m68k_target/specs

%files -n %arm_target-%name
%_bindir/%arm_target-*
%_usr/%arm_target
%dir %_libdir/gcc-lib
%_libdir/gcc-lib/%arm_target
%exclude %_libdir/gcc-lib/%arm_target/specs
%ghost %config(noreplace,missingok) %verify(not size mtime md5) %_libdir/gcc-lib/%arm_target/specs

%changelog
* Wed May 18 2005 Sir Raorn <raorn@altlinux.ru> 2.3-alt1
- Built for ALT Linux (based on prc-tools.spec from tarball)


